#include <windows.h>
#include <htmlhelp.h>
#include <process.h>
#include <wchar.h>
#include <TCHAR.H>
//#include "stdafx.h"
/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher 
//   and for replaying the games by Tomas Peceny, March 2004.

  Revision: 1991-01-20
  Modified by Daryl Baker for use in MS WINDOWS environment

  Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
  Copyright (c) 1988, 1989, 1990  John Stanback

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/
 
#include <windowsx.h>	
#include <windows.h>		  /* required for all Windows applications */
#include <TCHAR.H > //
#include <string.h>
#include <time.h>

#include "gnuchess.h"

#include "defs.h"
#include "chess.h"
#include "resource.h"//
#include "saveopen.h"
#include "color.h"

/* All units defined in pixels */

#define BRD_HORZFRONT   48
#define BRD_HORZBACK    32
#define BRD_VERT        32
#define BRD_EDGE        8
#define BRD_HORZMARGIN  32
#define BRD_BACKMARGIN  5
#define BRD_FRONTMARGIN 5

//const TCHAR tSPACE=' ';// with UNICODE, the higher byte is 0 and tSPACE==L' ' 

DWORD clrBackGround;       /* rgb structures for various colors */
DWORD clrBlackSquare;
DWORD clrWhiteSquare;
DWORD clrBlackPiece;
DWORD clrWhitePiece;
DWORD clrText;

static HBRUSH hBrushBackGround;

short boarddraw[64];       /* Display copies of the board */
short colordraw[64];       /* Needed because while computer is calculating*/
                           /* moves it updates board and color thus you can*/
                           /* not repaint the screen accuratly */

struct PIECEBITMAP pieces[7];

extern int HlasProtiPravidlum;
STARTUPINFO	Sinf;
PROCESS_INFORMATION	Pinf;
TCHAR szAppName[30];
extern TCHAR lpChessini[];
TCHAR TITUL_Chess[30];
TCHAR lpBtp[5];// ".btp"
TCHAR lpChs[5];// ".chs"
TCHAR lpAsterisk[5];// " *"
TCHAR lpEmpty[1]={0};// ""
TCHAR lpMutexName[30];
#ifdef UNICODE //
	TCHAR lpSpace[2]=L" ";//
#else
	TCHAR lpSpace[2]=" ";//
#endif
TCHAR lpBackSl[5];// "\\"
TCHAR lpR_R[5];// "r"
TCHAR lpW_W[5];// "w"
extern TCHAR  ColorStr[2][15];// == {"White", "Black"};
extern TCHAR lpProcento_d_c[5];
HINSTANCE hInst;              /* current instance */ // HINSTANCE instead of HANDLE
HANDLE hInstTP; // the same
HWND hWndTP;// the main window
HMENU hMenuTP; // the same as hMenu
extern int BylaNewGame, PrvniNaTahu;//
extern int UmiHint;// 
extern TCHAR BookTitleVen[100];//

int FlagTimoutKonce=FALSE;//
int KrizekCasu; // TRUE.. after Undo, Redo, Side...Switch not at the game beginning, appends '#' to the Clock times displayed
extern short computerSta,playerSta,FlagDraw;//
short boardFirst,colorFirst;//
int StareFirst;//
int UndoRemoveMozne=FALSE;//
int Pripona;
HANDLE hAccel;

extern char mvstr[4][6];
extern char *hBook;//GLOBALHANDLE hBook;
int coords = 1;

static int FirstSq = -1;         /* Flag is a square is selected */
/*static*/ int GotFirst = FALSE;
static int EditActive = FALSE;   /* Edit mode? */
int User_Move = TRUE;     /* User or computer's turn */// static 

static HMENU hMainMenu;
int Pole;//
extern int NahodneOtevreni, ComputerMates, Zobraz=TRUE,//
	BylSwitch; // 
extern TCHAR Titul[30+MAX_PATH];//
extern int HvezdickaStale;//
int HvezdickaBTP;// file opened as Book, full number of moves loaded has been done ...FALSE
extern short GameCntBezHvezdicky;//
TCHAR CmdJmenoOtevreni[2 * MAX_PATH];//
extern TCHAR AdresaKnihovny[MAX_PATH];
extern TCHAR AdresaMinula[MAX_PATH];// at first "..\\partie\\"; to be overwritten, always ends with '\'
OPENFILENAME OpenTP;//
TCHAR FileNameTP[MAX_PATH],FileTitleTP[65];//
TCHAR TitulHelp[MAX_PATH]=_T("does not exist");
HWND ZapominaneOkno,OknoHelp=(HWND)(-1)// not 0
				,OknoHledani;//
int FlagAkceler=TRUE;// enables "accelerators" for undo,redo,remove,switch,hint and the respective menu items
void  MakePathName (void);//
int Invertovano(void);// not reliable

BOOL CALLBACK FileSaveDlgProc (HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);

void ModalniMessageBox ( HWND hWnd, int str_num, int str1_num )
{
   TCHAR str[400], str1[20];
   LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
					 str_num, str, 400);
   LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE), 
	             str1_num, str1, 20);
   MessageBox ( hWnd, str, str1, MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL );
}

BOOL CALLBACK EnumFunkce(HWND  hWnd,	// handle to parent window,
							LPARAM  lParam) 	// application-defined value
{TCHAR Buf[MAX_PATH];
 GetWindowText(hWnd,Buf,MAX_PATH-1);
 if(_tcsstr(Buf,TitulHelp)==Buf)
  {OknoHledani=hWnd;
	return FALSE;
  }
 return TRUE;
}

BOOL CALLBACK enum_Jedno(HWND hwnd, LPARAM lParam)//
{ZapominaneOkno=hwnd;
 GetWindowText(hwnd,TitulHelp,MAX_PATH-1);
 return(1);
}

HWND NajdiOknoHelp(void) //
{int iYy;
 OknoHledani=0;
 for (iYy=0; !OknoHledani && iYy < 100; iYy++)
  {if(!EnumWindows((WNDENUMPROC)EnumFunkce,0)) // 0 jsem si vymyslel
		break;
  }
 return OknoHledani;
}

void DejKurzor(int PoleK)// sets the cursor to the middle of PoleK
{int x=PoleK%8,y=PoleK/8;
 POINT aptl[4],aptlPrum;
 QuerySqCoords ( x,y, aptl);
 aptlPrum.x=(aptl[0].x+aptl[1].x+aptl[2].x+aptl[3].x)/4;
 aptlPrum.y=(aptl[0].y+aptl[1].y+aptl[2].y+aptl[3].y)/4;
 ClientToScreen(hWndTP,       // window handle for source coordinates
					&aptlPrum);  // pointer to structure containing screen coordinates
 SetCursorPos(aptlPrum.x,aptlPrum.y);
}

int NajdiKurzor(void)// returns the square, where is the cursor, or -1
{POINT Bod;//
 GetCursorPos(&Bod);
 ScreenToClient(hWndTP,        // window handle for source coordinates
					&Bod);   // address of structure containing coordinates
 return HitTest (Bod.x, Bod.y);// ysq*8 + xsq , or -1			   
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
                  int nCmdShow);// HINSTANCE instead of HANDLE

/*static*/ void  MakeHelpPathName (TCHAR * szFileName);
#define EXE_NAME_MAX_SIZE  128
void Redo (HWND hWnd);
void ProhodStrany();
void ProhodCasy();//
void GetStartupTimeControls (void);//
void NapisHvezdicku(HWND hWnd,int MaBytHvezdicka);//

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
                  int nCmdShow)
{
    HWND hWnd;
    MSG msg;
    POINTS pt;// POINT pt;
	 LPTSTR ZaMezerou;//
#ifdef UNICODE //
	 DWORD dwVersion= GetVersion(); 
//	 OSVERSIONINFO VerzeSyst;
//	 int Uspech;
//	 VerzeSyst.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
//	 Uspech=GetVersionEx(&VerzeSyst);   not reliable
//#ifdef _DEBUG
//    if(!Uspech)
//	   {DWORD Chyba=GetLastError();
//		}
//#endif
//	 if(VerzeSyst.dwPlatformId==VER_PLATFORM_WIN32s ||
//		 VerzeSyst.dwPlatformId==VER_PLATFORM_WIN32_WINDOWS)
    if (dwVersion >= 0x80000000)
      {MessageBox (NULL,L"This UNICODE version of Chess is not intended for Windows 95, Windows 98 or Millenium Windows. "
								L"Use the ANSI version.", 
								L"Chess", MB_OK|MB_APPLMODAL);
//		 return (0); not sure about higher versions, user must try
		}
	 LoadString (hInstance, CHESSU_INI, lpChessini, 30);
#else
	 LoadString (hInstance, CHESS_INI, lpChessini, 30);
#endif //UNICODE

	 LoadString (hInstance, TITUL_CHESS, TITUL_Chess, 30);
	 LoadString (hInstance, SZ_APPNAME, szAppName, 30);
	 LoadString (hInstance, _BTP_BTP, lpBtp, 5);
	 LoadString (hInstance, _CHS_CHS, lpChs, 5);
	 LoadString (hInstance, ASTERISK_, lpAsterisk, 5);
	 LoadString (hInstance, BACK_SLASH, lpBackSl, 5);
	 LoadString (hInstance, R_R, lpR_R, 5);
	 LoadString (hInstance, W_W, lpW_W, 5);
	 LoadString (hInstance, WHITE_, ColorStr[0], 15);
	 LoadString (hInstance, BLACK_, ColorStr[1], 15);
	 LoadString (hInstance, PROCENTO_D_C, lpProcento_d_c, 5);    
	 LoadString (hInstance, MUTEX_NAME, lpMutexName, 30);

	 MakePathName();//
    lpCmdLine ++;

    if (!(hAccel = LoadAccelerators(hInstance, szAppName)))// here
        return FALSE;
	 if (!CreateMutex(NULL,// LPSECURITY_ATTRIBUTES lpMutexAttributes, pointer to security attributes
					 FALSE,//	BOOL bInitialOwner, flag for initial ownership
					 lpMutexName))// LPCTSTR lpName,  pointer to mutex-object name
	  {DWORD NaChybu;
		NaChybu=GetLastError();// for debugging only
	  }
	 else
		if(GetLastError()==ERROR_ALREADY_EXISTS)
		  {ModalniMessageBox (NULL, TWICE_NOT_POSSIBLE, TITUL_CHESS);
			return (0);
		  }
    if (!hPrevInstance)
	   if (!ChessInit(hInstance)) return (0);

    hInst = hInstance;			/* Saves the current instance	     */
	 hInstTP = hInstance; //

    QueryBoardSize (&pt);

    /* Create the mailn window.  It will be autosized in WM_CREATE message */
    hWnd = CreateWindow(szAppName,	szAppName,
      	(WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN) & ~WS_THICKFRAME 
				& ~WS_MAXIMIZEBOX,// & ~WS_SYSMENU hides the icon, // |WS_MINIMIZEBOX does not work
         CW_USEDEFAULT, CW_USEDEFAULT,// 0,0,   It has not helped to repair accelerator, simultaneously with
         CW_USEDEFAULT, CW_USEDEFAULT,// 0,0,    .
         NULL,	NULL,	hInstance,	NULL);

    if (!hWnd)	return (0);
	 hWndTP=hWnd;//

    ShowWindow(hWnd, nCmdShow);			  /* Shows the window	     */

   /* Initialize chess */
   if (init_main ( hWnd ) ) {
      SMessageBox (hWnd, IDS_INITERROR,TITUL_CHESS);
      FreeGlobals ();
      return (0);
   }

	_tcscpy(CmdJmenoOtevreni,GetCommandLine());//
	while(CmdJmenoOtevreni[_tcsclen(CmdJmenoOtevreni)-1]==_T(' '))
		 CmdJmenoOtevreni[_tcsclen(CmdJmenoOtevreni)-1]=0;// right trimming
	ZaMezerou=_tcsstr(CmdJmenoOtevreni,lpSpace); // ++ see lower
	if(ZaMezerou==NULL)
		goto Ven;
	while(*(++ZaMezerou) == _T(' '));// left trimming
   if(ZaMezerou[0])//
	  {Pripona=_tcsstr(_tcslwr(ZaMezerou),lpBtp)-&ZaMezerou[_tcsclen(ZaMezerou)-4];
	   if(Pripona<=0 && -2<=Pripona)
		  {TCHAR *pPosledniBacksl,*pMinulaBacksl=ZaMezerou;
		   if(GetOpenings(hWnd,ZaMezerou))
				goto Ven;//
			while(pMinulaBacksl=_tcsstr(pMinulaBacksl,lpBackSl))
			  {pMinulaBacksl++;
				pPosledniBacksl=pMinulaBacksl;
			  }
			_tcscpy(Titul,TITUL_Chess);
			_tcscat(Titul,pPosledniBacksl);
			SetWindowText(hWnd,Titul);//
			HvezdickaBTP=TRUE;// By saving it the file would be different (if any)
				 		//  from the opened one. HvezdickaBTP changes when full number
						//  of moves are reached.
// not necessary here, it is in NewGame()  HvezdickaStale=FALSE;//
			NapisHvezdicku(hWnd,HvezdickaStale);//
		  }
		Pripona=_tcsstr(_tcslwr(ZaMezerou),lpChs)-&ZaMezerou[_tcsclen(ZaMezerou)-4];
	   if(Pripona<=0 && -2<=Pripona)
		  {TCHAR *pPosledniBacksl,*pMinulaBacksl=ZaMezerou;
         if(GetGame(hWnd,ZaMezerou))//
				goto Ven;//
			ShowSidetoMove();//
			while(pMinulaBacksl=_tcsstr(pMinulaBacksl,lpBackSl))
			  {pMinulaBacksl++;
				pPosledniBacksl=pMinulaBacksl;
			  }
			_tcscpy(Titul,TITUL_Chess);
			_tcscat(Titul,pPosledniBacksl);
			SetWindowText(hWnd,Titul);//
// not necessary here, it is in NewGame()  HvezdickaStale=FALSE;//
		  }
	  }
Ven:
   UpdateWindow(hWnd);				  /* Sends WM_PAINT message  */
// hAccel = LoadAccelerators (hInstance, szAppName);// tranmissed above
//  player = opponent; transferred with change to NewGame()
//  ShowSidetoMove (); transferred to NewGame()

   while (GetMessage(&msg, NULL, 0, 0)) {// (GetMessage(&msg, NULL, NULL, NULL)) 
      if ( !TranslateAccelerator (hWnd, hAccel, &msg) ) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }

    return (msg.wParam);	   /* Returns the value from PostQuitMessage */
}

void ProhodJenStrany()//
{computer = otherside[computer];
 opponent = otherside[opponent];
}

void ProhodMeze()//
{int iStara=TCminutesWhite;
 TCminutesWhite=TCminutesBlack;
 TCminutesBlack=iStara;
}

void ProhodCasy()//
{struct TimeControlRec tStara=TimeControl;
 TimeControl.clock[computer]=tStara.clock[opponent];
 TimeControl.clock[opponent]=tStara.clock[computer];
 if(!TCflag)
	{if(computer==white)
			Level = 60 * (long) TCminutesWhite;
	 else
			Level = 60 * (long) TCminutesBlack;
	}
}

LRESULT CALLBACK ChessWndProc( HWND hWnd, unsigned message, WPARAM wParam, LPARAM lParam)
{  HMENU hMenu;
   PAINTSTRUCT ps;
   HDC hDC;
   TEXTMETRIC tm;
   int i;
	int FlagSwitche;//
   POINTS point;// POINT point;
	TCHAR FilterTP[200],RetezTP[400],RetezTP1[10];//
	TCHAR *PointerTP;

   switch (message) {
		case MSG_TP_PREHRAJ: // znaka Pehrvn proti ach
   //podle    case MSG_MANUAL_ENTRY_POINT:
   //      strcpy ( str, mvstr[0] );
   //      temp = VerifyMove ( hWnd, str, 0, &mv);
        {char strPr[10];
			unsigned short mvPr;
			short Figura=(wParam>>10) & 7;
			int JeVychoziRada=(wParam>>14) & 1; // logick, TRUE ...VychoziSloupec znamen vchoz adu
		   short BilyCerny=(wParam>>13) & 1;
			short Sl,Ra,VychoziSloupec=(wParam>>6) & 0xf;//8 ... nen uren
			short SloupecNa=(wParam>>3) & 7;
			short RadaNa=(wParam) & 7;
			if(!flag.force)
			  {ModalniMessageBox (hWnd, NO_MOVE_NO_FORCE, TITUL_CHESS);
				break;
			  }
		   if(BilyCerny!=player)
			  {ModalniMessageBox (hWnd, PLAYER_NOT_CORRECT, TITUL_CHESS);
				break;
			  }
			for(Sl=0;Sl<8;Sl++)
			  if(JeVychoziRada || (VychoziSloupec==8 || Sl==VychoziSloupec))
				for(Ra=0;Ra<8;Ra++)
			     if(!JeVychoziRada || (VychoziSloupec==8 || Ra==VychoziSloupec))
					if(board[8*Ra+Sl]==Figura && color[8*Ra+Sl]==BilyCerny)
					  {int iYy;
					   // algebraic notation 
						mvstr[0][0] = (char) ('a'+Sl);
						mvstr[0][1] = (char) ('1'+Ra);
						mvstr[0][2] = (char) ('a'+SloupecNa);
						mvstr[0][3] = (char) ('1'+RadaNa);
						mvstr[0][4] = '\0';
						strcpy ( strPr, mvstr[0] );
						HlasProtiPravidlum=FALSE;
						iYy=VerifyMove ( hWnd, strPr, 0, &mvPr);
						HlasProtiPravidlum=TRUE;
					   if(iYy)
						  {ElapsedTime (1);
							if ( flag.force ) 
							  {computer = opponent;
								opponent = otherside[computer];
							  }
//							if ( mv != hint)
//							  {Sdepth = 0;
//								ft = 0;
//								PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
//							  } 
//							else 
							  {PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
							   goto Ven;
							  }
						  }
				     }
			ModalniMessageBox (hWnd, MOVE_NECESSARY, TITUL_CHESS);
Ven:
			break;
		  }
	   case WM_CREATE: {			    /* message: window being created */
         int xchar, ychar;

         GetStartupColors ( szAppName);

         hBrushBackGround = CreateSolidBrush ( clrBackGround );

         for ( i=pawn; i<pawn+6; i++ ) pieces[i].piece = LoadBitmap (hInst, MAKEINTRESOURCE(PAWNBASE+i));
         for ( i=pawn; i<pawn+6; i++ ) pieces[i].mask = LoadBitmap (hInst, MAKEINTRESOURCE(PAWNBASE+6+i));
         for ( i=pawn; i<pawn+6; i++ ) pieces[i].outline = LoadBitmap (hInst, MAKEINTRESOURCE(PAWNBASE+12+i));


         hDC = GetDC (hWnd);
         GetTextMetrics ( hDC, &tm);
         xchar = tm.tmMaxCharWidth;
         ychar = tm.tmHeight+tm.tmExternalLeading;

         /*Autosize main window */
         QueryBoardSize (&point);            
         SetWindowPos( hWnd, hWnd, 0,0,
                 point.x+GetSystemMetrics(SM_CXFRAME)*2+50,
                 point.y+GetSystemMetrics(SM_CYFRAME)*2+GetSystemMetrics(SM_CYMENU)+
                 GetSystemMetrics(SM_CYCAPTION) + ychar * 2,// + ychar,
                 SWP_NOMOVE | SWP_NOZORDER);

         ReleaseDC ( hWnd, hDC);

         InitHitTest ();
         Create_Children ( hWnd, hInst, xchar, ychar);
         break;
      }

     case MSG_DESTROY:
			flag.timeout = true;//
			flag.bothsides = false;//
			if(!FlagAkceler)//
			     {MessageBeep (MB_ICONEXCLAMATION);
					SMessageBox (hWnd, CANNOT_END_WHILE_COMPUTER_THINKS,TITUL_CHESS);
					FlagTimoutKonce=TRUE;
               break;
				  }
         LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            REALLY_WANT_TO_END, RetezTP, 70);
         if ( MessageBox ( hWnd,//
						RetezTP, TITUL_Chess,
						MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) != IDYES)
             break;
         DestroyWindow ( hWnd );
         break;

     case WM_DESTROY: {		  /* message: window being destroyed */
         DeleteObject (hBrushBackGround);
         Hittest_Destructor ();
      //   if ( hBook )
			FreeBook();
         FreeGlobals ();
         SaveColors ( szAppName);
         PostQuitMessage(0);
	      break;
      }

      case WM_PAINT:

         if ( FirstSq != -1 ) {        /*Properly repaint hilighted square*/
            POINT pt; RECT rect;
            QuerySqOrigin ( FirstSq%8, FirstSq/8, &pt);
            rect.left = pt.x; rect.right=pt.x+48;
            rect.top = pt.y-48; rect.bottom = pt.y;
            InvalidateRect (hWnd, &rect, FALSE);
         }

         hDC = BeginPaint ( hWnd, &ps);
         Draw_Board ( hDC, flag.reverse, clrBlackSquare, clrWhiteSquare );
         if ( coords ) DrawCoords ( hDC, flag.reverse, clrBackGround, clrText);
         DrawAllPieces ( hDC, flag.reverse, boarddraw, colordraw, clrBlackPiece, clrWhitePiece );
         EndPaint ( hWnd, &ps);

         if ( FirstSq != -1 ) HiliteSquare ( hWnd, FirstSq);
         break;

      case WM_CTLCOLOR:     /*Enable setting colors for the message controls*/
      {
         POINT point;
         if ( HIWORD(lParam) == CTLCOLOR_STATIC) {
            UnrealizeObject ( hBrushBackGround );
            SetBkColor ((HDC)wParam, clrBackGround);
            SetBkMode ((HDC)wParam, TRANSPARENT);
            SetTextColor ((HDC)wParam, clrText);
            point.x = point.y = 0;
            ClientToScreen ( hWnd, &point);
            SetBrushOrgEx ((HDC)wParam, point.x, point.y,NULL);// SetBrushOrg (wParam, point.x, point.y);
            return (DWORD) hBrushBackGround;
         } else
            return DefWindowProc ( hWnd, message, wParam, lParam);
      }

      case WM_ERASEBKGND:
      {
         RECT rect;
         UnrealizeObject ( hBrushBackGround);
         GetClientRect ( hWnd, &rect);
         FillRect ( (HDC)wParam, &rect, hBrushBackGround);
         return 1;
      }

      case WM_INITMENUPOPUP:
         if ( !EditActive ) Init_Menus (hWnd, wParam, lParam);
         break;

      case WM_LBUTTONDOWN:
         /* If computer is thinking on human's time stop it at the first
            button click.  add test to ensure that "human" can't interupt
            the computer from thinking through its turn */
         if ( User_Move ) {
            flag.timeout = true;
            flag.bothsides = false;
         }

         /* Don't continue unless reason to */
         if ( !(EditActive || User_Move)) break;

         point = MAKEPOINTS (lParam );// MAKEPOINT (lParam );
      {
         int Hit;

         Hit = HitTest (point.x, point.y );

         if ( Hit == -1 ){
            if ( FirstSq != -1) {
               UnHiliteSquare ( hWnd, FirstSq);
               GotFirst = FALSE;
               FirstSq = -1;
            }
            break;
         }

         if ( GotFirst ) {
            UnHiliteSquare( hWnd, FirstSq);
            GotFirst = FALSE;

            if ( EditActive == TRUE) {
               PostMessage ( hWnd, MSG_EDITBOARD,((FirstSq<<8)|Hit), (LONG) NULL);
            } else if ( User_Move == TRUE) {
               PostMessage ( hWnd, MSG_USER_ENTERED_MOVE, ((FirstSq<<8)|Hit), (LONG) NULL);
            }
            FirstSq = -1;
         } else {
            GotFirst = TRUE;
            FirstSq = Hit;
            HiliteSquare ( hWnd, Hit);
         }
      }
         break;

      case MSG_EDITBOARD:
      {
         int Square, First;

         if ( flag.reverse ) {
            First = 63 - ((wParam>>8) & 0xff);
            Square  = 63 - (wParam & 0xff);
         } else {
            First = (wParam>>8) & 0xff;
            Square  = wParam & 0xff;
         }
         
         board[Square] = board[First];
         color[Square] = color[First];
			if(EditActive)//
			 {if(Square==First)// 
			  {boardFirst=board[First];
			   colorFirst=color[First];
				StareFirst=First;
				if(!UndoRemoveMozne)
				  {
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            UNDO_REMOVE,RetezTP, 20);
					AppendMenu ( hMenuTP, MF_STRING, MSG_TP_UNDOREMOVE,RetezTP);
					DrawMenuBar ( hWnd);
				  }
				UndoRemoveMozne=TRUE;
			  }
			  else
			  {if(UndoRemoveMozne)
				  {DeleteMenu( hMenuTP,MSG_TP_UNDOREMOVE,MF_BYCOMMAND); 
					DrawMenuBar ( hWnd);
				  }
				UndoRemoveMozne=FALSE;//
			  }
			 }
         board[First] = no_piece;
         color[First] = neutral;

         UpdateDisplay (hWnd, First, Square, false, false);
      }
         break;

      case MSG_USER_MOVE:
			computerSta=computer;//
			playerSta=player;//
         if ( flag.bothsides && !flag.mate ) {
            SelectMove ( hWnd, opponent, 1);
            if ( flag.beep ) MessageBeep (0);
            PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
         } else if (!flag.mate) {
            User_Move = TRUE;

            ft = 0;
            player = opponent;
            ShowSidetoMove ();
         {
            /* Set up to allow computer to think while user takes move*/
            int tmp; unsigned short mv; char s[10];
            if ( hint>0 && !flag.easy && Book == NULL) {
               time0 = time ( NULL);
               algbr ( hint>>8, hint&0xff, false);
               strcpy ( s, mvstr[0]);
               tmp = epsquare;
               if ( VerifyMove (hWnd, s,1, &mv) ) {
                  SelectMove ( hWnd, computer, 2);
                  VerifyMove ( hWnd, mvstr[0], 2, &mv);
                  if ( Sdepth>0 ) Sdepth --;
               }
               ft = time (NULL) - time0;
               epsquare = tmp;
            }
            }
         }
         break;

      case MSG_USER_ENTERED_MOVE:
      {
         int temp; unsigned short mv; int Square,First; char str[10];
         int algbr_flag;
         User_Move = FALSE;
/*         player = opponent;*/

         /* Fix coord's if user "reversed" board */
         if ( flag.reverse ) {
            First = 63 - ((wParam>>8) & 0xff);
            Square  = 63 - (wParam & 0xff);
         } else {
            First = (wParam>>8) & 0xff;
            Square  = wParam & 0xff;
         }
         /* Logic to allow selection for pawn promotion */
         if ( (board[First] == pawn) &&( (Square <8) || (Square>55)) ) {
            algbr_flag = promote + PromoteDialog (hWnd, hInst);
         } else algbr_flag = 0;
         algbr ( First, Square, algbr_flag);

      /* Entry point for manual entry of move */
      case MSG_MANUAL_ENTRY_POINT:

         strcpy ( str, mvstr[0] );
         
         temp = VerifyMove ( hWnd, str, 0, &mv);
         if ( !temp)
		PostMessage ( hWnd, MSG_USER_MOVE, 0, (long)NULL);
         else {
            ElapsedTime (1);
            if ( flag.force ) {
               computer = opponent;
               opponent = otherside[computer];
//				 ProhodStrany();//
            }
            if ( mv != hint) {
               Sdepth = 0;
               ft = 0;
               PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
            } else {
               PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
            }
         }
      }
         break;

      case MSG_COMPUTER_MOVE:
         if ( !(flag.quit || flag.mate || flag.force) ) {
				computerSta=computer;//
				playerSta=player;//
            SelectMove ( hWnd, computer, 1);
				if(BylSwitch)
				  {ProhodMeze();//
					ProhodCasy();//
					BylSwitch=FALSE;//
					et=0;//
					UpdateClocks();//
				  }
           if ( flag.beep ) MessageBeep (0);
			  UmiHint=TRUE;
         }
         PostMessage ( hWnd, MSG_USER_MOVE, 0, (long)NULL);
         break;


      case WM_CHAR:
 if ( wParam == VK_ESCAPE ) {
//				  {HWND ChildOknoHelp=FindWindow(
//					_T("HH Parent"),//LPCTSTR lpClassName,  // pointer to class name
//					_T("HTML Help")//LPCTSTR lpWindowName  // pointer to window name
//															);
//						if(!ChildOknoHelp)
//							goto BezHelp;
//						ShowWindow(ChildOknoHelp,SW_MINIMIZE); 
//					  }
//BezHelp:
            ShowWindow ( hWnd, SW_MINIMIZE);
         }
         break;

      case WM_KEYDOWN:
			if(wParam == VK_F1) // compensation for the accelerator that does not work
            PostMessage ( hWnd, MSG_WM_COMMAND, MSG_TP_INDEX, 0);

			if(wParam == VK_BACK) // compensation for the accelerator that does not work
			  {int SuccessTP;//
				if(!(FlagAkceler && !GotFirst) || EditActive || !(GameCnt>0))
			     {MessageBeep (MB_ICONEXCLAMATION);
               break;
				  }
			   SuccessTP=PostMessage ( hWnd, MSG_WM_COMMAND, MSG_TP_UNDO, 0);
			   if(!SuccessTP)// for debugging
				  {int ErrorTP=GetLastError();
				  }
			  }

			if(wParam == VK_RIGHT)//
			  {int PoleSta,PoleNevim;
				int y;
				int x;
				if((PoleNevim=NajdiKurzor())==-1)
					PoleSta=Pole;
				else
					PoleSta=PoleNevim;
				y=PoleSta/8;
				x=PoleSta%8;
				if(x>=7 || !FlagAkceler)
					  {MessageBeep(MB_ICONEXCLAMATION);
	               break;
					  }
				x++;
				Pole=8 * y + x;
				DejKurzor(Pole);
  			  }

			if(wParam == VK_LEFT)//
			  {int PoleSta,PoleNevim;
				int y;
				int x;
				if((PoleNevim=NajdiKurzor())==-1)
					PoleSta=Pole;
				else
					PoleSta=PoleNevim;
				y=PoleSta/8;
				x=PoleSta%8;
				if(x<=0 || !FlagAkceler)
					  {MessageBeep(MB_ICONEXCLAMATION);
	               break;
					  }
				x--;
				Pole=8 * y + x;
				DejKurzor(Pole);
			  }
			if(wParam == VK_UP)//
			  {int PoleSta,PoleNevim;
				int y;
				int x;
				if((PoleNevim=NajdiKurzor())==-1)
					PoleSta=Pole;
				else
					PoleSta=PoleNevim;
				y=PoleSta/8;
				x=PoleSta%8;
				if(y>=7 || !FlagAkceler)
					  {MessageBeep(MB_ICONEXCLAMATION);
	               break;
					  }
				y++;
				Pole=8 * y + x;
				DejKurzor(Pole);
			  }
			if(wParam == VK_DOWN)//
			  {int PoleSta,PoleNevim;
				int y;
				int x;
				if((PoleNevim=NajdiKurzor())==-1)
					PoleSta=Pole;
				else
					PoleSta=PoleNevim;
				y=PoleSta/8;
				x=PoleSta%8;
				if(y<=0 || !FlagAkceler)
					  {MessageBeep(MB_ICONEXCLAMATION);
	               break;
					  }
				y--;
				Pole=8 * y + x;
				DejKurzor(Pole);
			  }
			if(wParam == VK_SPACE)
	        {POINT Bod;
			   long lParamTP;
			   if(!FlagAkceler)
					  {MessageBeep(MB_ICONEXCLAMATION);
	               break;
					  }
				GetCursorPos(&Bod);
				ScreenToClient(hWndTP,        // window handle for source coordinates
					&Bod);   // address of structure containing coordinates
				lParamTP=Bod.y;
				lParamTP=lParamTP<<16 | Bod.x;
	         PostMessage (hWnd, WM_LBUTTONDOWN, MK_LBUTTON, lParamTP);
			  }

         if ( User_Move && wParam == VK_F2 ) {   /* To invoke manual move entry */
            char tmpmove[8];
				if(!(FlagAkceler/* && !Invertovano()*/) || EditActive)
			     {MessageBeep (MB_ICONEXCLAMATION);
               break;
				  }
            flag.timeout = true;
            flag.bothsides = false;
            if ( GotFirst ) {
               UnHiliteSquare( hWnd, FirstSq);
               GotFirst = FALSE;
               FirstSq = -1;
            }
            if ( DoManualMoveDlg (hInst, hWnd, tmpmove) ){
               strcpy ( mvstr[0], tmpmove);
               PostMessage ( hWnd, MSG_MANUAL_ENTRY_POINT, 0, 0);
            }
         }
         /* Allow Break to abort bothsides (autoplay) mode */
         /* And abort computer thinking */
         if ( wParam == VK_PAUSE ) {//
            flag.timeout = true;
            flag.bothsides = false;
				ShowPlayers();//
         } 
			if(wParam == VK_RETURN ) //
			  {if(!(FlagAkceler && !GotFirst) || EditActive || GameCnt >= GameCountNejv)
			     {MessageBeep (MB_ICONEXCLAMATION);
               break;
				  }
				PostMessage ( hWnd, MSG_WM_COMMAND, MSG_TP_REDO, 0);
			  }
			if(wParam == VK_F4) // compensation for the accelerator that does not work
			  {if(!(FlagAkceler && !GotFirst) || EditActive || !(GameCnt>1))
			     {MessageBeep (MB_ICONEXCLAMATION);
               break;
				  }
				PostMessage ( hWnd, MSG_WM_COMMAND, MSG_TP_REMOVE, 0);
			  }
			if(wParam == VK_F3) // "accelerator" for hint
			  {if(!(FlagAkceler && !GotFirst) || EditActive || flag.force)
			     {MessageBeep (MB_ICONEXCLAMATION);
               break;
				  }
            PostMessage ( hWnd, MSG_WM_COMMAND, MSG_CHESS_HINT, 0);
			  }
			if(wParam == VK_TAB) // "accelerator" for Side...switch
			  {if(!(FlagAkceler && !GotFirst && !flag.force) || EditActive)
			     {MessageBeep (MB_ICONEXCLAMATION);
					SMessageBox (hWnd, CANNOT_SWITCH_SIDES,TITUL_CHESS);
               break;
				  }
            PostMessage ( hWnd, MSG_WM_COMMAND, MSG_CHESS_SWITCH, 0);
			  }
         break;

      case WM_SYSCOMMAND:
         if (  wParam == SC_CLOSE ) {     /*Abort easy mode */
            flag.timeout = true;
            flag.bothsides = false;
            PostMessage ( hWnd, MSG_DESTROY, 0, 0);
         } else return (DefWindowProc(hWnd, message, wParam, lParam));
         break;

      case WM_CLOSE:
         flag.timeout = true;
         flag.bothsides = false;
         PostMessage ( hWnd, MSG_DESTROY, 0, 0);
         break;
         
      /* Menu item processing */
      case WM_COMMAND:

         /* When we execute a command stop any look ahead */
         /* Then call actual routine to process */
			if(wParam!=MSG_HELP_INDEX && wParam!=MSG_CHESS_ABOUT)//
           {flag.timeout = true;
				flag.bothsides = false;
			  }
			PostMessage ( hWnd, MSG_WM_COMMAND, wParam, lParam);
         break;
      
      case MSG_WM_COMMAND:
         switch ( wParam ) {
            case MSG_CHESS_QUIT:
/*               DestroyWindow ( hWnd);*/
                 PostMessage ( hWnd, MSG_DESTROY, 0, 0);
               break;

            case MSG_CHESS_HINT://
					if(!UmiHint)
				     {SMessageBox (hWndTP, NO_PROPER_HINT_IS_AVAILABLE,TITUL_CHESS);
	               break;
					  }
					if(!FlagAkceler || EditActive || flag.force)
				     {MessageBeep (MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, HINT_DOES_NOT_WORK,TITUL_CHESS);
	               break;
					  }
					DoHintDlg (hInst,hWnd);//
               // GiveHint (hWnd);
               break;

            case MSG_CHESS_LIST:
					*FileNameTP=0;//""

               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            COMPUTER_ACTIVITY_LISTING, FilterTP, 50);//"Computer activity listing"
					PointerTP=FilterTP+_tcsclen(FilterTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            _LST_,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Computer activity listing\0*.lst"
					PointerTP+=_tcsclen(RetezTP)+1;
					*PointerTP=0;//"Computer activity listing\0*.lst\0"

					OpenTP.lpstrFilter       = FilterTP;
					OpenTP.lStructSize=sizeof(OPENFILENAME);//
					OpenTP.hwndOwner =hWnd;//
					OpenTP.hInstance         = hInstTP;
					OpenTP.lpstrCustomFilter = NULL;
					OpenTP.nMaxCustFilter    = 0;
					OpenTP.nFilterIndex      = 1;
					OpenTP.lpstrFile         = FileNameTP;
					OpenTP.nMaxFile          = MAX_PATH;
					OpenTP.lpstrFileTitle    = FileTitleTP;
					OpenTP.nMaxFileTitle     = 65;
					OpenTP.lpstrInitialDir   = AdresaMinula;//Windows95: has no effect
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVE_EVALUATION_ACTIVITY,RetezTP, 70);
					OpenTP.lpstrTitle        = RetezTP;
					OpenTP.nFileOffset       = 0;
					OpenTP.nFileExtension    = 0;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            L_S_T,RetezTP1, 10);
					OpenTP.lpstrDefExt       = RetezTP1;
					OpenTP.lCustData         = (LPARAM)0;//(LPARAM)&sMyData;
					OpenTP.lpfnHook 		    = NULL;//ComDlg32DlgProc;
					OpenTP.lpTemplateName    = NULL;//MAKEINTRESOURCE(IDD_COMDLG32);
					OpenTP.Flags             =/* OFN_SHOWHELP|*/ 
							 OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT 
							 | OFN_LONGNAMES | OFN_HIDEREADONLY;//|OFN_EXPLORER;

               if (!GetSaveFileName(&OpenTP)) 
                  break;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            LST_LST,RetezTP1, 10);
					if(_tcsstr(_tcslwr(FileNameTP),RetezTP1)+1-FileNameTP!=OpenTP.nFileExtension)
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, LISTING_SHOULD_HAVE_EXTENSION,TITUL_CHESS);
						break;
					  }
               ListGame ( hWnd, OpenTP.lpstrFile/*pof.szPathName*/);
               break;

            case MSG_CHESS_SAVE:
					if(flag.mate)//
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVED_NOW_INCORRECT_UNDO, RetezTP, 400);
						if ( MessageBox ( hWnd,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
                     break;
					  }
					if(GameCnt<GameCountNejv)//
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVED_NOW_NOT_ALL_MOVES, RetezTP, 400);
						if ( MessageBox ( hWnd,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
                     break;
					  }
				/*	TimeControl.clock[player]-=(short)et;*/ et=0;//
					UpdateClocks();//
					*FileNameTP=0;// ""

               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_BOTH, FilterTP, 50);//"Chess games both"
					PointerTP=FilterTP+_tcsclen(FilterTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            CHS_BTP,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_SAVED,RetezTP, 50);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            _CHS_,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)\0*.chs"
					PointerTP+=_tcsclen(RetezTP)+1;
					*PointerTP=0;//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)\0*.chs\0"

					OpenTP.lpstrFilter       = FilterTP;
					OpenTP.lStructSize=sizeof(OPENFILENAME);//
					OpenTP.hwndOwner =hWnd;//
					OpenTP.hInstance         = hInstTP;
//					OpenTP.lpstrFilter       = games_both_games_saved;// the second ending '\0' should be set by system
					OpenTP.lpstrCustomFilter = NULL;
					OpenTP.nMaxCustFilter    = 0;
					OpenTP.nFilterIndex      = 2;
					OpenTP.lpstrFile         = FileNameTP;
					OpenTP.nMaxFile          = MAX_PATH;
					OpenTP.lpstrFileTitle    = FileTitleTP;
					OpenTP.nMaxFileTitle     = 65;
					OpenTP.lpstrInitialDir   = AdresaMinula;//Windows95: has no effect
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVE_THE_GAME,RetezTP, 70);
					OpenTP.lpstrTitle        = RetezTP;
					OpenTP.nFileOffset       = 0;
					OpenTP.nFileExtension    = 0;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            C_H_S,RetezTP1, 10);
					OpenTP.lpstrDefExt       = RetezTP1;
					OpenTP.lCustData         = (LPARAM)0;//(LPARAM)&sMyData;
					OpenTP.lpfnHook 		    = NULL;//ComDlg32DlgProc;
					OpenTP.lpTemplateName    = NULL;//MAKEINTRESOURCE(IDD_COMDLG32);
					OpenTP.Flags             =/* OFN_SHOWHELP|*/ 
							 OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT 
							 | OFN_LONGNAMES | OFN_HIDEREADONLY;//|OFN_EXPLORER;

               if (!GetSaveFileName(&OpenTP)) 
                  break;
					if(_tcsstr(_tcslwr(FileNameTP),lpChs)+1-FileNameTP!=OpenTP.nFileExtension)
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, WRONG_EXTENSION_SAVED,TITUL_CHESS);
						break;
					  }
					_tcscpy(AdresaMinula,OpenTP.lpstrFile);
					AdresaMinula[OpenTP.nFileOffset]=0;

               if(!SaveGame ( hWnd, OpenTP.lpstrFile/*pof.szPathName*/))
					  {_tcscpy(Titul,TITUL_Chess);
						SetWindowText(hWnd,_tcscat(Titul,OpenTP.lpstrFileTitle));//
						HvezdickaStale=FALSE;
						HvezdickaBTP=FALSE;
					  }
               break;

            case MSG_TP_SAVEBOOK://
					if(!BylaNewGame)
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            NOT_STARTED_FROM_BEGINNING, RetezTP, 400);
						if ( MessageBox ( hWnd,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
                     break;
					  }
					if(GameCnt<GameCountNejv)//
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVED_NOW_NOT_ALL_MOVES_BOOK, RetezTP, 400);
						if ( MessageBox ( hWnd,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
                     break;
					  }

					if ( !DialogBox ( hInst, MAKEINTRESOURCE(SAVEBOOK), hWnd, FileSaveDlgProc))
						break;
					SetWindowText ( hJmenoOtevreni, BookTitleVen);

					*FileNameTP=0;// ""

               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_BOTH, FilterTP, 50);//"Chess games both"
					PointerTP=FilterTP+_tcsclen(FilterTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            CHS_BTP,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_WRITTEN,RetezTP, 50);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games written (Book, *.bTP)"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            _BTP_,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games written (Book, *.bTP)\0*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
					*PointerTP=0;//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)\0*.chs\0"

					OpenTP.lpstrFilter       = FilterTP;
					OpenTP.lStructSize=sizeof(OPENFILENAME);//
					OpenTP.hwndOwner =hWnd;//
					OpenTP.hInstance         = hInstTP;
//					OpenTP.lpstrFilter       = games_both_games_written;// the second ending '\0' should be set by system
					OpenTP.lpstrCustomFilter = NULL;
					OpenTP.nMaxCustFilter    = 0;
					OpenTP.nFilterIndex      = 2;
					OpenTP.lpstrFile         = FileNameTP;
					OpenTP.nMaxFile          = MAX_PATH;
					OpenTP.lpstrFileTitle    = FileTitleTP;
					OpenTP.nMaxFileTitle     = 65;
					OpenTP.lpstrInitialDir   = AdresaMinula;//Windows95: has no effect
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            SAVE_WRITTEN_GAME,RetezTP, 70);
					OpenTP.lpstrTitle        = RetezTP;
					OpenTP.nFileOffset       = 0;
					OpenTP.nFileExtension    = 0;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            C_H_S,RetezTP1, 10);
					OpenTP.lpstrDefExt       = RetezTP1;
					OpenTP.lCustData         = (LPARAM)0;//(LPARAM)&sMyData;
					OpenTP.lpfnHook 		    = NULL;//ComDlg32DlgProc;
					OpenTP.lpTemplateName    = NULL;//MAKEINTRESOURCE(IDD_COMDLG32);
					OpenTP.Flags             =/* OFN_SHOWHELP|*/ 
							 OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT 
							 | OFN_LONGNAMES | OFN_HIDEREADONLY;//|OFN_EXPLORER;

               if (!GetSaveFileName(&OpenTP)) 
					  {SetWindowText ( hJmenoOtevreni, lpEmpty);
                  break;
					  }
					if(_tcsstr(_tcslwr(FileNameTP),lpBtp)+1-FileNameTP!=OpenTP.nFileExtension)
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, WRONG_EXTENSION_BOOK,TITUL_CHESS);
						SetWindowText ( hJmenoOtevreni, lpEmpty);
						break;
					  }
					_tcscpy(AdresaMinula,OpenTP.lpstrFile);
					AdresaMinula[OpenTP.nFileOffset]=0;
               if(!SaveBook (OpenTP.lpstrFile))
					  {_tcscpy(Titul,TITUL_Chess);
						SetWindowText(hWnd,_tcscat(Titul,OpenTP.lpstrFileTitle));//
						HvezdickaStale=FALSE;
						HvezdickaBTP=FALSE;
						GameCntBezHvezdicky=GameCnt;//
					  }
					else
						SetWindowText ( hJmenoOtevreni, lpEmpty);
               break;

            case MSG_CHESS_GET:
					*FileNameTP=0;//""
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_BOTH, FilterTP, 50);//"Chess games both"
					PointerTP=FilterTP+_tcsclen(FilterTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            CHS_BTP,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_SAVED,RetezTP, 50);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            _CHS_,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)\0*.chs"
					PointerTP+=_tcsclen(RetezTP)+1;
					*PointerTP=0;//"Chess games both\0*.chs;*.bTP\0Chess games saved (*.chs)\0*.chs\0"

					OpenTP.lpstrFilter       = FilterTP;
					OpenTP.lStructSize=sizeof(OPENFILENAME);//
					OpenTP.hwndOwner =hWnd;//
					OpenTP.hInstance         = hInstTP;
//					OpenTP.lpstrFilter       = games_both_games_saved;// the second ending '\0' should be set by system
					OpenTP.lpstrCustomFilter = NULL;
					OpenTP.nMaxCustFilter    = 0;
					OpenTP.nFilterIndex      = 2;
					OpenTP.lpstrFile         = FileNameTP;
					OpenTP.nMaxFile          = MAX_PATH;
					OpenTP.lpstrFileTitle    = FileTitleTP;
					OpenTP.nMaxFileTitle     = 65;
					OpenTP.lpstrInitialDir   = AdresaMinula;//Windows95: has no effect
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            OPEN_SAVED_GAME,RetezTP, 70);
					OpenTP.lpstrTitle        = RetezTP;
					OpenTP.nFileOffset       = 0;
					OpenTP.nFileExtension    = 0;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            C_H_S,RetezTP1, 10);
					OpenTP.lpstrDefExt       = RetezTP1;
					OpenTP.lCustData         = (LPARAM)0;//(LPARAM)&sMyData;
					OpenTP.lpfnHook 		    = NULL;//ComDlg32DlgProc;
					OpenTP.lpTemplateName    = NULL;//MAKEINTRESOURCE(IDD_COMDLG32);
					OpenTP.Flags             =/* OFN_SHOWHELP|*/ 
							 OFN_FILEMUSTEXIST|OFN_LONGNAMES | OFN_HIDEREADONLY;//|OFN_EXPLORER;

               if (!GetOpenFileName(&OpenTP))
                  break;
					if(_tcsstr(_tcslwr(FileNameTP),lpChs)+1-FileNameTP!=OpenTP.nFileExtension)
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWnd, WRONG_EXTENSION_SAVED_OPEN,TITUL_CHESS);
						break;
					  }
					_tcscpy(AdresaMinula,OpenTP.lpstrFile);
					AdresaMinula[OpenTP.nFileOffset]=0;
					Zobraz=FALSE;
               NewGame(hWnd);//
					Zobraz=TRUE;
               if(GetGame ( hWnd,OpenTP.lpstrFile))
						break;//
					ShowSidetoMove();//
					_tcscpy(Titul,TITUL_Chess);
					SetWindowText(hWnd,_tcscat(Titul,OpenTP.lpstrFileTitle));//
					SetWindowText ( hComputerMove, lpEmpty);//
               break;

				case MSG_TP_OPENBOOK://
					*FileNameTP=0;//""
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_BOTH, FilterTP, 50);//"Chess games both"
					PointerTP=FilterTP+_tcsclen(FilterTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            CHS_BTP,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            GAMES_WRITTEN,RetezTP, 50);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games written (Book, *.bTP)"
					PointerTP+=_tcsclen(RetezTP)+1;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            _BTP_,RetezTP, 16);
					_tcscpy(PointerTP,RetezTP);//"Chess games both\0*.chs;*.bTP\0Chess games written (Book, *.bTP)\0*.bTP"
					PointerTP+=_tcsclen(RetezTP)+1;
					*PointerTP=0;//"Chess games both\0*.chs;*.bTP\0Chess games written (Book, *.bTP)\0*.chs\0"

					OpenTP.lpstrFilter       = FilterTP;
					OpenTP.lStructSize=sizeof(OPENFILENAME);//
					OpenTP.hwndOwner =hWnd;//
					OpenTP.hInstance         = hInstTP;
//					OpenTP.lpstrFilter       = games_both_games_written;// the second ending '\0' should be set by system
					OpenTP.lpstrCustomFilter = NULL;
					OpenTP.nMaxCustFilter    = 0;
					OpenTP.nFilterIndex      = 2;
					OpenTP.lpstrFile         = FileNameTP;
					OpenTP.nMaxFile          = MAX_PATH;
					OpenTP.lpstrFileTitle    = FileTitleTP;
					OpenTP.nMaxFileTitle     = 65;
					OpenTP.lpstrInitialDir   = AdresaMinula;//Windows95: has no effect
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            OPEN_WRITTEN_GAME,RetezTP, 70);
					OpenTP.lpstrTitle        = RetezTP;
					OpenTP.nFileOffset       = 0;
					OpenTP.nFileExtension    = 0;
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            B_T_P,RetezTP1, 10);
					OpenTP.lpstrDefExt       = RetezTP1;
					OpenTP.lCustData         = (LPARAM)0;//(LPARAM)&sMyData;
					OpenTP.lpfnHook 		    = NULL;//ComDlg32DlgProc;
					OpenTP.lpTemplateName    = NULL;//MAKEINTRESOURCE(IDD_COMDLG32);
					OpenTP.Flags             =/* OFN_SHOWHELP|*/ 
							 OFN_FILEMUSTEXIST|OFN_LONGNAMES | OFN_HIDEREADONLY;//|OFN_EXPLORER;

               if (!GetOpenFileName(&OpenTP)) //!DoFileOpenDlg ( hInst, hWnd, "*.btp", ".btp",0x0, FileName, &pofBookTP)
                  break;
					if(_tcsstr(_tcslwr(FileNameTP),lpBtp)+1-FileNameTP!=OpenTP.nFileExtension)
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, WRONG_EXTENSION_BOOK_OPEN,TITUL_CHESS);
						break;
					  }
					_tcscpy(AdresaMinula,OpenTP.lpstrFile);
					AdresaMinula[OpenTP.nFileOffset]=0;
               NewGame(hWnd);
 //              if ( hBook )
					FreeBook();
					if(!GetOpenings ( hWnd,OpenTP.lpstrFile))//
					  {_tcscpy(Titul,TITUL_Chess);
						SetWindowText(hWnd,_tcscat(Titul,OpenTP.lpstrFileTitle));//
						HvezdickaBTP=TRUE;// By saving it the file would be different (if any)
					 		//  from the opened one. HvezdickaBTP changes when full number
							//  of moves are reached.
						NapisHvezdicku(hWnd,HvezdickaStale);//
						SetWindowText ( hComputerMove, lpEmpty);//
					  }
               break;

            case MSG_CHESS_NEW:
               NewGame(hWnd);
//               if ( hBook ) 
					FreeBook();
               GetOpenings ( hWnd,lpEmpty);
               break;

            case MSG_CHESS_ABOUT:
	         	DialogBox(hInst, MAKEINTRESOURCE(AboutBox), hWnd, About);// lpProcAbout
               break;

            case MSG_CHESS_EDIT:
				   if(computer!=black && flag.mate)
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            NOT_BLACK_MATE, RetezTP, 400);
						if ( MessageBox ( hWnd,RetezTP, TITUL_Chess,
								MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL) == IDYES)
                     break;
					  }
					BylaNewGame=FALSE;//
               EditActive = TRUE;
               hMenu = CreateMenu ();
					hMenuTP=hMenu;//
					LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            DONE_DONE_, RetezTP, 20);
               AppendMenu ( hMenu, MF_STRING, MSG_CHESS_EDITDONE,RetezTP);
               hMainMenu = GetMenu ( hWnd);
               SetMenu ( hWnd, hMenu);
               DrawMenuBar ( hWnd);
               break;

            case MSG_CHESS_EDITDONE:
					UndoRemoveMozne=FALSE;//
               EditActive = FALSE;
               hMenu = GetMenu ( hWnd );
					hMenuTP=hMenu;//
               SetMenu ( hWnd, hMainMenu );
               DrawMenuBar ( hWnd );
               DestroyMenu ( hMenu );
               GameCnt = 0;
					GameCountNejv=GameCnt;//
					GameCntBezHvezdicky=GameCnt;//
               Game50 = 1;
               ZeroRPT ();
               Sdepth = 0;
					flag.mate=FALSE;//
					FlagDraw=FALSE;//
					ComputerMates=FALSE;//
					BylSwitch=FALSE;//
					PrvniNaTahu=player;//
					SetWindowText ( hComputerMove, lpEmpty);//
               InitializeStats ();
					KrizekCasu=TRUE;
					SetTimeControl ();//
// is in SetTimeControl() in ElapsedTime()		UpdateClocks();//
					HvezdickaStale=TRUE;
					NapisHvezdicku(hWnd,HvezdickaStale);//
               PostMessage ( hWnd, MSG_USER_MOVE, 0, (long)NULL);
               break;

            case MSG_TP_UNDOREMOVE:
					if(UndoRemoveMozne && EditActive)
					  {board[StareFirst]=boardFirst;//
						color[StareFirst]=colorFirst;//
						UpdateDisplay (hWnd, StareFirst, StareFirst, false, false);
					  }
					else
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, PROGRAM_ERROR_TP,TITUL_CHESS);
						break;
					  }
					DeleteMenu( hMenuTP,MSG_TP_UNDOREMOVE,MF_BYCOMMAND); 
					DrawMenuBar ( hWnd);
					UndoRemoveMozne=FALSE;//
               break;

            case MSG_CHESS_REVIEW:
               ReviewDialog ( hWnd, hInst );
               break;

            case MSG_CHESS_TEST:
               TestDialog (hWnd, hInst);
               break;
        
            case MSG_CHESS_HASH:
               flag.hash = !flag.hash;
               break;

            case MSG_CHESS_BEEP:
               flag.beep = !flag.beep;
               break;

            case MSG_CHESS_COORD:
               coords = !coords;
               UpdateDisplay(hWnd,0,0,1,0);
               break;

            case MSG_CHESS_BOTH:
               flag.bothsides = !flag.bothsides;
					KrizekCasu=TRUE;
					UpdateClocks();
					flag.force=false;//
               flag.easy = true;
               Sdepth = 0;
					if(flag.bothsides)//
					  {LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),
                            COMPUTER_BOTH, RetezTP, 30);
						SetWindowText ( hComputerColor, RetezTP);
						PostMessage ( hWnd, MSG_USER_MOVE, 0, (long)NULL);
					  }
					break;

            case MSG_CHESS_BOOK:
               if ( Book != NULL ) {
                  FreeBook ();
                  Book = NULL;
               }
               break;

				case MSG_TP_RANDOMBOOK:
				  {NahodneOtevreni= !NahodneOtevreni;
               break;
				  }

            case MSG_CHESS_POST:
               if ( flag.post ) {
                  SendMessage ( hStats, WM_SYSCOMMAND, SC_CLOSE, 0 );
                  flag.post = false;
               } else {
                  StatDialog ( hWnd, hInst);
                  flag.post = TRUE;
               }
               break;

            case MSG_CHESS_AWIN: {
               TCHAR str[40];
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
                            IDS_SETAWIN, str, 40),
               Awindow = DoGetNumberDlg ( hInst, hWnd, str, Awindow);
               break;
            }

            case MSG_CHESS_BWIN: {
               TCHAR str[40];
               LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
                            IDS_SETBWIN, str, 40),
               Bwindow = DoGetNumberDlg ( hInst, hWnd, str, Bwindow);
               break;
            }

            case MSG_CHESS_CONTEMP: {
               TCHAR str[40];
               LoadString ((HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
                            IDS_SETCONTEMPT, str, 40),
               contempt = DoGetNumberDlg ( hInst, hWnd, str, contempt);
               break;
            }

            case MSG_TP_UNDO:
            case MSG_CHESS_UNDO:
					if(!flag.easy) //
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, UNDO_NOT_IF_NOT_EASY,TITUL_CHESS);
						break;
					  }
               if ( GameCnt >0 ) {
                  Undo(hWnd);
						UpdateClocks();//
                  ShowSidetoMove ();
               }
               break;

            case MSG_TP_REDO:
					if(!flag.easy) //
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, REDO_NOT_IF_NOT_EASY,TITUL_CHESS);
						break;
					  }
               Redo(hWnd);
               player = opponent;
					UpdateClocks();//
               ShowSidetoMove ();
               break;

            case MSG_TP_REMOVE:
            case MSG_CHESS_REMOVE:
					if(!flag.easy) //
					  {MessageBeep(MB_ICONEXCLAMATION);
						SMessageBox (hWndTP, UNDO_NOT_IF_NOT_EASY,TITUL_CHESS);
						break;
					  }
               if ( GameCnt > 1) {
                  Undo(hWnd); Undo (hWnd);
						UpdateClocks();//
                  ShowSidetoMove ();

               }
               break;

            case MSG_CHESS_FORCE:					
            //   Book = NULL;
               flag.force = !flag.force;
					if(flag.force)
						SetWindowText ( hComputerMove, lpEmpty);//
            //   player = opponent;
               ShowPlayers ();
					ShowJmenoOtevreni();
					SetWindowText ( hComputerMove, lpEmpty);//
               break;

            case MSG_CHESS_RANDOM:
               if ( dither==0 ) dither=6; else dither = 0;
               break;

            case MSG_CHESS_EASY:
               flag.easy = !flag.easy;
               break;

            case MSG_CHESS_DEPTH: {
               TCHAR str[40];
               LoadString ( (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE),// GetWindowWord(hWnd,GWW_HINSTANCE),
                            IDS_MAXSEARCH, str, 40),
               MaxSearchDepth = DoGetNumberDlg ( hInst, hWnd, str, MaxSearchDepth);
               break;
            }

            case MSG_CHESS_REVERSE:
               flag.reverse = !flag.reverse;
               ShowPlayers ();
               UpdateDisplay(hWnd,0,0,1,0);
               break;

            case MSG_CHESS_SWITCH:
               ProhodJenStrany();//
               if(GameCnt<1);
					else
						KrizekCasu=TRUE;
					BylSwitch=TRUE;//
					if (!TCflag)
						SetTimeControl();//
					UpdateClocks();//
               Sdepth = 0;
               ShowPlayers ();
					ShowJmenoOtevreni();
               PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
               break;

            case MSG_CHESS_BLACK:
					if(computer==white)
						FlagSwitche=TRUE;
					else
						FlagSwitche=FALSE;
					if(FlagSwitche)
					  {ProhodJenStrany();//
               if(GameCnt<1);
					else
						KrizekCasu=TRUE;
						BylSwitch=TRUE;//
						if (!TCflag)
							SetTimeControl();//
						UpdateClocks();//
					  }
               Sdepth = 0;
               ShowPlayers ();
			//		ShowJmenoOtevreni(); makes nothing visible
               PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
               break;

            case MSG_CHESS_WHITE:
					if(computer==black)
						FlagSwitche=TRUE;
					else
						FlagSwitche=FALSE;
					if(FlagSwitche)
					  {ProhodJenStrany();//
               if(GameCnt<1);
					else
						KrizekCasu=TRUE;
						BylSwitch=TRUE;//
						if (!TCflag)
							SetTimeControl();//
						UpdateClocks();//
					  }
               Sdepth = 0;
               ShowPlayers ();
			//		ShowJmenoOtevreni(); makes nothing visible
               PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (long)NULL);
               break;

            case IDM_BACKGROUND:
               if (ColorDialog ( hWnd, hInst, wParam) ) {
                  InvalidateRect (hWnd, NULL, TRUE);
                  DeleteObject (hBrushBackGround);
                  hBrushBackGround = CreateSolidBrush ( clrBackGround );

                  /*Invalidate the text windows so they repaint */
                  InvalidateRect (hComputerColor, NULL, TRUE);
                  InvalidateRect (hJmenoOtevreni, NULL, TRUE);
                  InvalidateRect (hComputerMove, NULL, TRUE);
                  InvalidateRect (hWhosTurn, NULL, TRUE);
                  InvalidateRect (hClockWhite, NULL, TRUE);
                  InvalidateRect (hClockBlack, NULL, TRUE);
                  InvalidateRect (hMsgBlack, NULL, TRUE);
                  InvalidateRect (hMsgWhite, NULL, TRUE);
               }
               break;

            case IDM_BLACKSQUARE:
               if (ColorDialog ( hWnd, hInst, wParam) ) {
                  InvalidateRect (hWnd, NULL, TRUE);
               }
               break;

            case IDM_WHITESQUARE:
               if (ColorDialog ( hWnd, hInst, wParam) ) {
                  InvalidateRect (hWnd, NULL, TRUE);
               }
               break;

            case IDM_BLACKPIECE:
               if (ColorDialog ( hWnd, hInst, wParam) ) {
                  InvalidateRect (hWnd, NULL, TRUE);
               }
               break;

            case IDM_WHITEPIECE:
               if (ColorDialog ( hWnd, hInst, wParam) ) {
                  InvalidateRect (hWnd, NULL, TRUE);
               }
               break;

            case IDM_TEXT:
               if ( ColorDialog (hWnd, hInst, wParam) ) {
                  /*Invalidate the text windows so they repaint */
                  InvalidateRect (hWnd, NULL, TRUE);
                  InvalidateRect (hComputerColor, NULL, TRUE);
						InvalidateRect (hJmenoOtevreni, NULL, TRUE);
                  InvalidateRect (hComputerMove, NULL, TRUE);
                  InvalidateRect (hWhosTurn, NULL, TRUE);
                  InvalidateRect (hClockWhite, NULL, TRUE);
                  InvalidateRect (hClockBlack, NULL, TRUE);
                  InvalidateRect (hMsgBlack, NULL, TRUE);
                  InvalidateRect (hMsgWhite, NULL, TRUE);
               }
               break;

            case IDM_DEFAULT:
               SetStandardColors ();
               InvalidateRect (hWnd, NULL, TRUE);
               DeleteObject (hBrushBackGround);
               hBrushBackGround = CreateSolidBrush ( clrBackGround );

               /*Invalidate the text windows so they repaint */
               InvalidateRect (hComputerColor, NULL, TRUE);
					InvalidateRect (hJmenoOtevreni, NULL, TRUE);
               InvalidateRect (hComputerMove, NULL, TRUE);
               InvalidateRect (hWhosTurn, NULL, TRUE);
               InvalidateRect (hClockWhite, NULL, TRUE);
               InvalidateRect (hClockBlack, NULL, TRUE);
               InvalidateRect (hMsgBlack, NULL, TRUE);
               InvalidateRect (hMsgWhite, NULL, TRUE);
               break;

            case IDM_TIMECONTROL:
               if ( TimeControlDialog (hWnd, hInst, wParam) ) {
// here                  TCflag = (TCmoves>1);
// here                  SetTimeControl ();
               }
               break;

            case MSG_TP_INDEX:
            case MSG_HELP_INDEX: {//
					TCHAR  szHelpFileName[MAX_PATH];//[EXE_NAME_MAX_SIZE+1];
					MakeHelpPathName(szHelpFileName);
					HtmlHelp(hWnd,szHelpFileName,HH_DISPLAY_TOPIC,0L);
               break;
            }
         }
         break;

      default:            /* Passes it on if unproccessed    */
         return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (0);
}

/*static*/ void  MakeHelpPathName (TCHAR * szFileName)
{
   TCHAR *pcFileName;
	TCHAR RetezTP[30];
   int     nFileNameLen;

   nFileNameLen = GetModuleFileName(hInst,szFileName,EXE_NAME_MAX_SIZE);
   pcFileName = szFileName + nFileNameLen;

   while (pcFileName > szFileName) {
       if (*pcFileName == _T('\\') || *pcFileName == _T(':')) {
           *(++pcFileName) = 0;//'\0';
           break;
       }
   nFileNameLen--;
   pcFileName--;
   }

   if ((nFileNameLen+13) < EXE_NAME_MAX_SIZE) {
       LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                            CHESS_HLP,RetezTP, 30);
       lstrcat(szFileName, RetezTP);
   }

   else {
       LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                            QUESTION_MARK,RetezTP, 30);
       lstrcat(szFileName, RetezTP);
   }

   return;
}

void  MakePathName (void)//
{
   TCHAR *pcFileName;
	TCHAR	szFileNameTP[MAX_PATH],RetezTP[30];//
   int     nFileNameLen;

   nFileNameLen = GetModuleFileName(hInstTP,szFileNameTP,MAX_PATH);
   pcFileName = szFileNameTP + nFileNameLen;

   while (pcFileName > szFileNameTP) {
       if (*pcFileName == _T('\\') || *pcFileName == _T(':')) {
           *(++pcFileName) = 0;//'\0';
           break;
       }
 //  nFileNameLen--;
   pcFileName--;
   }
	_tcscpy(AdresaKnihovny,szFileNameTP);
   pcFileName-=2;
   while (pcFileName > szFileNameTP) {
       if (*pcFileName == _T('\\') || *pcFileName == _T(':')) {
           *(++pcFileName) = 0;//'\0';
           break;
       }
   pcFileName--;
   }
	_tcscpy(AdresaMinula,szFileNameTP);
   LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                            PARTIE_,RetezTP, 30);
	_tcscat(AdresaMinula,RetezTP);
}
