#include <fcntl.h>//
#include <sys/stat.h>//
#include <io.h> //
/*
  C source for GNU CHESS

// Fixed for learning chess game using Windows 95 and higher by Tomas Peceny, April 2002.

  Revision: 1990-09-30
  Modified by Daryl Baker for use in MS WINDOWS environment

  Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
  Copyright (c) 1988, 1989, 1990  John Stanback

  This file is part of CHESS.

  CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY.  No author or distributor accepts responsibility to anyone for
  the consequences of using it or for whether it serves any particular
  purpose or works at all, unless he says so in writing.  Refer to the CHESS
  General Public License for full details.

  Everyone is granted permission to copy, modify and redistribute CHESS, but
  only under the conditions described in the CHESS General Public License.
  A copy of this license is supposed to have been given to you along with
  CHESS so you can know your rights and responsibilities.  It should be in a
  file named COPYING.  Among other things, the copyright notice and this
  notice must be preserved on all copies.
*/

#include <windows.h>
#include <TCHAR.H >
#include <string.h>
#include <time.h>
#include <stdio.h>

#include "resource.h"
#include "gnuchess.h"
#include "defs.h"
#include "chess.h"

int HlasProtiPravidlum;
extern HANDLE hInst;        //      /* current instance */
extern int User_Move;//
extern int ComputerMates,BylSwitch,KrizekCasu;
extern TCHAR lpR_R[5];// "r"
extern TCHAR lpW_W[5];// "w"
extern TCHAR lpEmpty[1];// ""
extern TCHAR TITUL_Chess[30];
int UnicodeSaveBook=FALSE;


static short /*_based(_segname("_CODE"))*/ Stboard[64] =
{rook, knight, bishop, queen, king, bishop, knight, rook,
 pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
 rook, knight, bishop, queen, king, bishop, knight, rook};

static short /*_based(_segname("_CODE"))*/ Stcolor[64] =
{white, white, white, white, white, white, white, white,
 white, white, white, white, white, white, white, white,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
 black, black, black, black, black, black, black, black,
 black, black, black, black, black, black, black, black};

int mycntl1, mycntl2;

char mvstr[4][6];
long evrate;
int PositionFlag = 0;

#define pxx " PNBRQK"
#define qxx " pnbrqk"

extern short TCflag;
extern TCHAR BookTitleVen[100];//
extern int BylaNewGame;//
extern int PrvniNaTahu,FlagDraw;//
extern short computerSta,playerSta;//
extern HWND hWndTP;
extern int HvezdickaStale;
extern short GameCntBezHvezdicky;
void ProhodStrany();
void ProhodMeze();//
void ProhodCasy();//
void NapisHvezdicku(HWND hWnd,int MaBytHvezdicka);//
LPSTR Zhusti(LPTSTR SrcTP);
LPWSTR wZred(LPSTR Src);

void
Initialize (void)
{
  mycntl1 = mycntl2 = 0;
}

void
ExitChess (void)
{

}

void
Die (int Sig)
{
}

void
TerminateSearch (int Sig)
{
  flag.timeout = true;
  flag.bothsides = false;
}

void
algbr (short int f, short int t, short int flag)

/*
   Generate move strings in different formats.
*/

{
  int m3p;

  if (f != t)
    {
      /* algebraic notation */
      mvstr[0][0] = (char) ('a'+column (f));
      mvstr[0][1] = (char) ('1'+row (f));
      mvstr[0][2] = (char) ('a'+column (t));
      mvstr[0][3] = (char) ('1'+row (t));
      mvstr[0][4] = mvstr[3][0] = '\0';
      if ((mvstr[1][0] = pxx[board[f]]) == 'P')
        {
          if (mvstr[0][0] == mvstr[0][2])       /* pawn did not eat */
            {
              mvstr[2][0] = mvstr[1][0] = mvstr[0][2];  /* to column */
              mvstr[2][1] = mvstr[1][1] = mvstr[0][3];  /* to row */
              m3p = 2;
            }
          else
            /* pawn ate */
            {
              mvstr[2][0] = mvstr[1][0] = mvstr[0][0];  /* from column */
              mvstr[2][1] = mvstr[1][1] = mvstr[0][2];  /* to column */
              mvstr[2][2] = mvstr[0][3];
              m3p = 3;          /* to row */
            }
          mvstr[2][m3p] = mvstr[1][2] = '\0';
          if (flag & promote)
            {
              mvstr[0][4] = mvstr[1][2] = mvstr[2][m3p] = qxx[flag & pmask];
              mvstr[1][3] = mvstr[2][m3p + 1] = mvstr[0][5] = '\0';
            }
        }
      else
        /* not a pawn */
        {
          mvstr[2][0] = mvstr[1][0];
          mvstr[2][1] = mvstr[0][1];
          mvstr[2][2] = mvstr[1][1] = mvstr[0][2];      /* to column */
          mvstr[2][3] = mvstr[1][2] = mvstr[0][3];      /* to row */
          mvstr[2][4] = mvstr[1][3] = '\0';
          strcpy (mvstr[3], mvstr[2]);
          mvstr[3][1] = mvstr[0][0];
          if (flag & cstlmask)
            {
              if (t > f)
                {
                  strcpy (mvstr[1], "o-o");
                  strcpy (mvstr[2], "O-O");
                }
              else
                {
                  strcpy (mvstr[1], "o-o-o");
                  strcpy (mvstr[2], "O-O-O");
                }
            }
        }
    }
  else
    mvstr[0][0] = mvstr[1][0] = mvstr[2][0] = mvstr[3][0] = '\0';
}

int
VerifyMove (HWND hWnd, char *s, short int iop, short unsigned int *mv)

/*
   Compare the string 's' to the list of legal moves available for the
   opponent. If a match is found, make the move on the board.
*/

{
  static short pnt, tempb, tempc, tempsf, tempst, cnt;
  static struct leaf xnode;
  struct leaf  far *node;

  *mv = 0;
  if (iop == 2)
    {
      UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);
      return (false);
    }
  cnt = 0;
  MoveList (opponent, 2);
  pnt = TrPnt[2];
  while (pnt < TrPnt[3])
    {
      node = &Tree[pnt++];
      algbr (node->f, node->t, (short) node->flags);
      if (strcmp (s, mvstr[0]) == 0 || strcmp (s, mvstr[1]) == 0 ||
          strcmp (s, mvstr[2]) == 0 || strcmp (s, mvstr[3]) == 0)
        {
          cnt++;
          xnode = *node;
        }
    }
  if (cnt == 1)
    {
      MakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst, &INCscore);
      if (SqAtakd (PieceList[opponent][0], computer))
        {
          UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);
          if(HlasProtiPravidlum)
				SMessageBox (hWnd, IDS_ILLEGALMOVE, TITUL_CHESS);
          return (false);
        }
      else
        {
          if (iop == 1)
            return (true);
			 if(GameCnt<=GameCntBezHvezdicky)//
				HvezdickaStale=TRUE;
			 NapisHvezdicku(hWndTP,HvezdickaStale || GameCnt!=GameCntBezHvezdicky);//
          UpdateDisplay (hWnd, xnode.f, xnode.t, 0, (short) xnode.flags);
          if ((board[xnode.t] == pawn)
              || (xnode.flags & capture)
              || (xnode.flags & cstlmask))
            {
              Game50 = GameCnt;
              ZeroRPT ();
            }
          GameList[GameCnt].depth = GameList[GameCnt].score = 0;
          GameList[GameCnt].nodes = 0;
          ElapsedTime (1);
          GameList[GameCnt].time = (short) et;
          TimeControl.clock[opponent] -= et;
          --TimeControl.moves[opponent];
          *mv = (xnode.f << 8) | xnode.t;
          algbr (xnode.f, xnode.t, false);
          return (true);
        }
    }
  if (cnt > 1) SMessageBox (hWnd, IDS_AMBIGUOUSMOVE, TITUL_CHESS);
  return (false);
}

void
ElapsedTime (short int iop)

/*
  Determine the time that has passed since the search was started. If
  the elapsed time exceeds the target (ResponseTime+ExtraTime) then set
  timeout to true which will terminate the search.
*/

{
  et = time (NULL) - time0;
  if (et < 0)
    et = 0;
  ETnodes += 50;
  if (et > et0 || iop == 1)
    {
      if (et > ResponseTime + ExtraTime && Sdepth > 1)
        flag.timeout = true;
      et0 = et;
      if (iop == 1)
        {
          time0 = time (NULL);
          et0 = 0;
        }
      if (et > 0)
        /* evrate used to be Nodes / cputime I dont` know why */
        evrate = NodeCnt / (et + ft);
      else
        evrate = 0;
      ETnodes = NodeCnt + 50;
      UpdateClocks ();
    }
}

void
SetTimeControl (void)
{
  if (TCflag)
    {
      TimeControl.moves[white] = TimeControl.moves[black] = TCmoves;
      TimeControl.clock[white] = 60 * (long) TCminutesWhite;
      TimeControl.clock[black] = 60 * (long) TCminutesBlack;
    }
  else
    {
      TimeControl.moves[white] = TimeControl.moves[black] = 0;
      TimeControl.clock[white] = TimeControl.clock[black] = 0;
		if(computer==white)
			Level = 60 * (long) TCminutesWhite;
		else
			Level = 60 * (long) TCminutesBlack;
    }
  time0=time (NULL);
//  et = 0;// the same is set in ElapsedTime()
  ElapsedTime (1);
}

int //void
GetGame (HWND hWnd, TCHAR *fname)
{
  FILE *fd;
  int c;
  short sq;
  unsigned short m;

  struct GameRec tmp_rec;

  if ((fd = _tfopen (fname, lpR_R)) == NULL)
    {
      SMessageBox (hWnd, IDS_LOADFAILED, TITUL_CHESS);
      return -1;
    }
  BylaNewGame=FALSE;//
  fscanf (fd, "%hd%hd%hd", &computer, &opponent, &Game50);
  fscanf (fd, "%hd%hd", &castld[white], &castld[black]);
  fscanf (fd, "%hd%hd", &TCflag, &OperatorTime);
  fscanf (fd, "%ld%ld%hd%hd",
          &TimeControl.clock[white], &TimeControl.clock[black],
          &TimeControl.moves[white], &TimeControl.moves[black]);
  for (sq = 0; sq < 64; sq++)
    {
      fscanf (fd, "%hd%hd", &m, &Mvboard[sq]);
      board[sq] = (m >> 8);
      color[sq] = (m & 0xFF);
      if (color[sq] == 0)
        color[sq] = neutral;
      else
        --color[sq];
    }
  GameCnt = 0;
  c = '?';
  while (c != EOF)
    { ++GameCnt;
      c = fscanf (fd, "%hd%hd%hd%ld%hd%hd%hd", &tmp_rec.gmove,
                  &tmp_rec.score, &tmp_rec.depth,
                  &tmp_rec.nodes, &tmp_rec.time,
                  &tmp_rec.piece, &tmp_rec.color);
      GameList[GameCnt] = tmp_rec;
      if (GameList[GameCnt].color == 0)
        GameList[GameCnt].color = neutral;
      else
        --GameList[GameCnt].color;
    }

  GameCnt--;
  GameCountNejv=GameCnt;
  GameCntBezHvezdicky=GameCnt;//
  if (TimeControl.clock[white] > 0)
    TCflag = true;
  computer--;
  opponent--;
  player=opponent;//
  if(GameCnt%2==0)//
		PrvniNaTahu=player;//
  else
		PrvniNaTahu=otherside[player];//

  fclose (fd);

  InitializeStats ();
  Sdepth = 0;
  SetWindowText ( hJmenoOtevreni, lpEmpty);
  if(player==black)
		ProhodMeze();//
  UpdateClocks();
  UpdateDisplay (hWnd, 0, 0, 1, 0);
  return 0;//
}

int // void
SaveGame (HWND hWnd, TCHAR *fname)
{
  FILE *fd;
  short sq, i, c;

  if (NULL == (fd = _tfopen (fname, lpW_W)))
    {
      SMessageBox (hWnd, NOT_SAVED, TITUL_CHESS);
      return -1;//
    }

  fprintf (fd, "%d %d %d\n", computer + 1, opponent + 1, Game50);
  fprintf (fd, "%d %d\n", castld[white], castld[black]);
  fprintf (fd, "%d %d\n", TCflag, OperatorTime);
  fprintf (fd, "%ld %ld %d %d\n",
           TimeControl.clock[white], TimeControl.clock[black],
           TimeControl.moves[white], TimeControl.moves[black]);
  for (sq = 0; sq < 64; sq++)
    {
      if (color[sq] == neutral)
        c = 0;
      else
        c = color[sq] + 1;
      fprintf (fd, "%d %d\n", 256 * board[sq] + c, Mvboard[sq]);
    }
  for (i = 1; i <= GameCnt; i++)
    {
      if (GameList[i].color == neutral)
        c = 0;
      else
        c = GameList[i].color + 1;
      fprintf (fd, "%d %d %d %ld %d %d %d\n",
               GameList[i].gmove, GameList[i].score, GameList[i].depth,
               GameList[i].nodes, GameList[i].time,
               GameList[i].piece, c);
    }
  fclose (fd);
  GameCntBezHvezdicky=GameCnt;//
  return 0;
}

void
ListGame (HWND hWnd, TCHAR *fname)
{
  FILE *fd;
  short i, f, t;

  if ( (fd = _tfopen (fname, lpW_W)) == NULL) {
      SMessageBox (hWnd, CANNOT_WRITE_LST, TITUL_CHESS);
      return;
  }

  fprintf (fd, "\n");
  fprintf (fd, "       score  depth   nodes  time         ");
  fprintf (fd, "       score  depth   nodes  time\n");
  for (i = 1; i <= GameCnt; i++)
    {
      f = GameList[i].gmove >> 8;
      t = (GameList[i].gmove & 0xFF);
      algbr (f, t, false);
      fprintf (fd, "%5s  %5d     %2d %7ld %5d", mvstr[0],
               GameList[i].score, GameList[i].depth,
               GameList[i].nodes, GameList[i].time);

      if ((i % 2) == 0)
        fprintf (fd, "\n");
      else
        fprintf (fd, "         ");

    }
  fprintf (fd, "\n\n");
  fclose (fd);
}

void
Undo (HWND hWnd)

/*
  Undo the most recent half-move.
*/

{
  short f, t,
		  f0,t0;//
  f = GameList[GameCnt].gmove >> 8;
  t = GameList[GameCnt].gmove & 0xFF;
  f0 = GameList[GameCnt-1].gmove >> 8;
  t0 = GameList[GameCnt-1].gmove & 0xFF;
  if (board[t] == king && distance (t, f) > 1)
	 (void) castle (GameList[GameCnt].color, f, t, 2);
  else
    {
      /* Check for promotion: */
      if (board[t]!=king && abs(column(f)-column(t))<=1 && //
			((color[t] == white && row (f) == 6 && row (t) == 7)
          || (color[t] == black && row (f) == 1 && row (t) == 0)))
        {int from = f,Odpoved;//
         TCHAR lpPromotion[80];
         LoadString ((HINSTANCE)GetWindowLong(hWndTP,GWL_HINSTANCE),
                            WAS_IT_PROMOTION,lpPromotion, 80);
			Odpoved=MessageBox (hWndTP,lpPromotion,TITUL_Chess, MB_YESNOCANCEL);//
			if(Odpoved==IDCANCEL)
				return;
         if(Odpoved==IDNO)
				goto ZaPromotion;
         if ((color[t] == white && row (from) == 6)// ==1
              || (color[t] == black && row (from) == 1))// ==6
            board[t] = pawn;
			goto ZaPromotion;
        }
// Check for en passant:
      if ((board[t]==pawn && abs(column(f)-column(t))==1) 
		    && GameList[GameCnt].piece==0) //
		  {if(color[t] == white && row (f) == 4 && row (t) == 5)
			  {if(!(row(f0)==6 && column(f0)==column(t)
				 && row(t0)==4))
					SMessageBox (hWndTP, BAD_UNDO_EN_PASSANT, TITUL_CHESS);
				board[f] = board[t];
				color[f] = color[t];
				board[t-8] = pawn;
				color[t-8] = black;
				board[t] = no_piece;
				color[t] = neutral;
				goto Za_enPassant;
			  }
			if(color[t] == black && row (f) == 3 && row (t) == 2)
			  {if(!(row(f0)==1 && column(f0)==column(t)
				 && row(t0)==3))
					SMessageBox (hWndTP, BAD_UNDO_EN_PASSANT, TITUL_CHESS);
				board[f] = board[t];
				color[f] = color[t];
				board[t+8] = pawn;
				color[t+8] = white;
				board[t] = no_piece;
				color[t] = neutral;
				goto Za_enPassant;
			  }
		  }
ZaPromotion:
      board[f] = board[t];
      color[f] = color[t];
      board[t] = GameList[GameCnt].piece;
      color[t] = GameList[GameCnt].color;
Za_enPassant:
      if (color[t] != neutral)
        Mvboard[t]--;
      Mvboard[f]--;
    }
  if (TCflag)
    ++TimeControl.moves[color[f]];
  GameCnt--;
  if(flag.mate || FlagDraw)//
   {if(PrvniNaTahu==white)
		{if(GameCnt%2==1)
			computer=white;
		 else
			computer=black;
		}
	 else
		{if(GameCnt%2==1)
			computer=black;
		 else
			computer=white;
		}
	 opponent=otherside[computer];
   }
  else//
		ProhodStrany();//
  player=opponent;// here
  flag.mate = false;
  FlagDraw=FALSE;//
  ComputerMates=FALSE;//
  User_Move = TRUE;//
  Sdepth = 0;
  SetWindowText ( hComputerMove, lpEmpty);//
  UpdateDisplay (hWnd, 0, 0, 1, 0);
  NapisHvezdicku(hWndTP,HvezdickaStale || GameCnt!=GameCntBezHvezdicky);//
  KrizekCasu=TRUE;
  InitializeStats ();
}

void
Redo (HWND hWnd)

/*
//  Redo a half-move.
*/

{
  short f, t, 
			f0,t0;//
  f = GameList[GameCnt+1].gmove >> 8;
  t = GameList[GameCnt+1].gmove & 0xFF;
  f0 = GameList[GameCnt].gmove >> 8;
  t0 = GameList[GameCnt].gmove & 0xFF;
  if (board[f] == king && distance (t, f) > 1)
    (void) castle (GameList[GameCnt+1].color, f, t, 1);
  else
    {
// Check for en passant:
      if (board[f]==pawn && abs(column(f)-column(t))==1) 
		  {if((color[f] == white && row (f) == 4 && row (t) == 5)
				 && board[t-8]==pawn && color[t-8]==black
				 && row(f0)==6 && column(f0)==column(t)
				 && row(t0)==4)
			  {board[t] = board[f];
				color[t] = color[f];
				board[t-8] = no_piece;
				color[t-8] = neutral;
				board[f] = no_piece;
				color[f] = neutral;
				goto Za_enPassant;
			  }
			if((color[f] == black && row (f) == 3 && row (t) == 2)
				 && board[t+8]==pawn && color[t+8]==white
				 && row(f0)==1 && column(f0)==column(t)
				 && row(t0)==3)
			  {board[t] = board[f];
				color[t] = color[f];
				board[t+8] = no_piece;
				color[t+8] = neutral;
				board[f] = no_piece;
				color[f] = neutral;
				goto Za_enPassant;
			  }
		  }
      /* Check for promotion: */
      if (((color[f] == white && row (f) == 6 && row (t) == 7)
          || (color[f] == black && row (f) == 1 && row (t) == 0)) && board[f] == pawn)
			board[t] = PromoteDialog (NULL, hInst);
		else
			board[t] = board[f];
      color[t] = color[f];
      board[f] = no_piece;
      color[f] = neutral;
    }
Za_enPassant:
//_!  if (TCflag)
//_!    ++TimeControl.moves[color[f]];
  GameCnt++;
  ProhodStrany();
  Sdepth = 0;
  SetWindowText ( hComputerMove, lpEmpty);//
  UpdateDisplay (hWnd, 0, 0, 1, 0);
  NapisHvezdicku(hWndTP,HvezdickaStale || GameCnt!=GameCntBezHvezdicky);//
  KrizekCasu=TRUE;
  InitializeStats ();
}

int SaveBook(TCHAR *fname) //
{int Ukladany;
 int i,f,t,JeBily=TRUE;
 char TahBily[6];
 Ukladany=_topen(fname,_O_BINARY|_O_CREAT|_O_WRONLY,_S_IWRITE);//
 if (Ukladany==-1)
    {SMessageBox (hWndTP, NOT_SAVED, TITUL_CHESS);
     return -1;
    }
 vOtevreni=0;
 if(UnicodeSaveBook)
   {chOtevreni[0]=(unsigned char)0xFF;
	 chOtevreni[1]=(unsigned char)0xFE;
	 vOtevreni=2;
	}
   
#ifdef UNICODE
 if(UnicodeSaveBook)
  {vOtevreni+=2*swprintf((LPTSTR)&chOtevreni[vOtevreni],L"$%s\r\n",BookTitleVen);
   goto Ridke;
  }
 else
  {char *Zhus_ene=Zhusti(BookTitleVen);
   if(!Zhus_ene)
		return -2;
	vOtevreni+=sprintf(&chOtevreni[vOtevreni],"$%s\r\n",Zhus_ene);
	goto Huste;
  }
#else //#ndef UNICODE
 if(UnicodeSaveBook)
  {vOtevreni+=2*swprintf((LPWSTR)&chOtevreni[vOtevreni],L"$%s\r\n",wZred(BookTitleVen));
   goto Ridke;
  }
 else
  {vOtevreni+=sprintf(&chOtevreni[vOtevreni],"$%s\r\n",BookTitleVen);
	goto Huste;
  }
#endif//UNICODE
Ridke:
 for (i = 1; i <= GameCnt; i++) 
  {f = GameList[i].gmove >> 8;
   t = (GameList[i].gmove & 0xFF);
   algbr (f, t, false);
	if(JeBily)
	  {strcpy(TahBily,mvstr[0]);
		if(i == GameCnt)
			vOtevreni+=2*swprintf((LPWSTR)&chOtevreni[vOtevreni],L"%s\r\n",wZred(TahBily));
	  }
	else
     {wchar_t RetezTP[6];
	   wcscpy(RetezTP,wZred(mvstr[0])); // both Zred()'s point to the same address
	   vOtevreni+=2*swprintf((LPWSTR)&chOtevreni[vOtevreni],L"%s  %s\r\n",wZred(TahBily)
																						,RetezTP);
	  }
	JeBily = !JeBily;
  }
 vOtevreni+=2*swprintf((LPWSTR)&chOtevreni[vOtevreni],L"!\r\n");
 goto Konec;

Huste:
 for (i = 1; i <= GameCnt; i++) 
  {f = GameList[i].gmove >> 8;
   t = (GameList[i].gmove & 0xFF);
   algbr (f, t, false);
	if(JeBily)
	  {strcpy(TahBily,mvstr[0]);
		if(i == GameCnt)
			vOtevreni+=sprintf(&chOtevreni[vOtevreni],"%s\r\n",TahBily);
	  }
	else
		vOtevreni+=sprintf(&chOtevreni[vOtevreni],"%s  %s\r\n",TahBily,mvstr[0]);
	JeBily = !JeBily;
  }
 vOtevreni+=sprintf(&chOtevreni[vOtevreni],"!\r\n");

Konec:
 if(_write(Ukladany,chOtevreni,vOtevreni)!=vOtevreni)
  {SMessageBox (hWndTP, NOT_PROPERLY_SAVED, TITUL_CHESS);
	_close(Ukladany);
	return -3;
  }
 _close(Ukladany);
 return 0;
}